#include "localsetup.h"
#include "exec.h"

#include "hearts/player_id.h"
#include "general/helper.h"

#include "../options.h"

#include "localsetupwidget.h"

#include <qpushbutton.h>
#include <qlineedit.h>
#include <klocale.h>
#include <kdebug.h>
#include <kmessagebox.h>

#include <sys/types.h> // FreeBSD needs this before including <sys/socket.h>
#include <sys/socket.h>
#include <unistd.h>

#include <algorithm>

LocalSetup::LocalSetup( QWidget* parent, const char* name )
		: QWidget( parent, name ),
		widget_( new LocalSetupWidget( this, "localsetupwidget" ) )
{
#define SET_INIT( x ) setName( player_id::x, Options::playerName( player_id::x ) );
	HANDLE_ALL_PLAYER_IDS( SET_INIT );
}

void LocalSetup::setName( player_id::type who, QString name )
{
#define CASE( x ) if ( who == player_id::x ) widget_->x ## _ ->setText( name )

	HANDLE_ALL_PLAYER_IDS( CASE );
}

int LocalSetup::connect()
{
	enum { client, server };
	kdDebug() << "LocalSetup::execute()" << endl;
	int pipe[2];
	int stat;
	if ( socketpair( AF_LOCAL, SOCK_STREAM, PF_LOCAL, pipe ) < 0 ) {
			goto error;
	}
	stat = fork();
	if ( stat < 0 ) goto error;
	if ( stat > 0 ) {
#define SAVE(x)  Options::savePlayerName( player_id::x,widget_->x##Name() )
			SAVE( self );
			SAVE( right );
			SAVE( front );
			SAVE( left );
			::close( pipe[ server ] );
			char c = 0;
			::write( pipe[ client ], &c, 1);
			return pipe[ client ];
	} else {
			::close( pipe[ client ] );

			int fds[ 4 ];
			fds[ 0 ] = pipe[ server ];
			fds[ 1 ] = execute::computerClient( widget_->rightName() );
			fds[ 2 ] = execute::computerClient( widget_->frontName() );
			fds[ 3 ] = execute::computerClient( widget_->leftName() );
			if ( fds[ 1 ] < 0 ||
							fds[ 2 ] < 0 ||
							fds[ 3 ] < 0 ) {
					::close( pipe[ server ] );
					exit( 1 );
			}
			execute::server( fds );
			return 0;
	}
error:
	LOG_PLACE_NL();
	return 0;
}

#include "localsetup.moc"

